<?xml version="1.0" encoding="UTF-8"?>

<!--****************************************************************************************************************** 	
	created by: Laura Robinson
	contact: lrobinson@secstate.wa.gov
	create date: 2009-10-03
	update by lr: 2009-10-22 - fixed Date (digital)
	update by lr: 2009-10-27 - deleted scanner parameter and added all WRH fields
    update by er: 2009-11-19 - added Object ID and Notes columns, edited Resource identifier and Title columns
    update by lr: 2009-12-14 - fixed Date (digital), cleaned/consolidated code
	notes: this file was written and tested with the msxsl transformation processor and is meant to 
	tranform image_data.xml to specs_tab.txt, a tab-delimited format that follows the Washington Rural Heritage
	metadata specifications 
	*******************************************************************************************************************-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:et="http://ns.exiftool.ca/1.0/" xmlns:ExifTool="http://ns.exiftool.ca/ExifTool/1.0/" xmlns:System="http://ns.exiftool.ca/File/System/1.0/" xmlns:File="http://ns.exiftool.ca/File/1.0/" xmlns:IFD0="http://ns.exiftool.ca/EXIF/IFD0/1.0/" xmlns:Composite="http://ns.exiftool.ca/Composite/1.0/" version="1.0">
	<xsl:output method="text"/>
	<xsl:key name="uniqueItem" match="//File:FileName" use="substring-before(., '.')"/>
	<xsl:variable name="tab" select="'	'"/>
	<xsl:template match="/">
		<!--create header row-->
		<xsl:text>Resource identifier</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Title</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Title (alternative)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Creator</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Contributor</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Subject</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Topic</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Location (subject)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Location (coordinates)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Name(s) (subject)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Description</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Publisher (digital)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Publisher (original)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Date (digital)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Date (original)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Date (hidden)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Type</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Language (iso code)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Related item(s)</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Contributing institution</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Collection</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Access file format</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Access file requires</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Access file specifications</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Digitization specifications</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Source item specifications</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Notes</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Rights and use</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Transcript</xsl:text><xsl:value-of select="$tab"/>
		<xsl:text>Object ID</xsl:text><xsl:value-of select="$tab"/>
		<!--for each item from the _Web folder or each unique item from the _Archival folder, create a new row-->
		<xsl:for-each select="rdf:RDF/rdf:Description[contains(File:Directory, '_Web')] | rdf:RDF/rdf:Description[contains(File:Directory, '_Archival')][File:FileName[generate-id(.) = generate-id(key('uniqueItem', substring-before(., '.'))[1])]]"><xsl:text>
</xsl:text>
			<!--Variable for resource identifier (filename)-->
			<xsl:variable name="fileName">
				<xsl:value-of select="substring-before(File:FileName, '.')"/>
			</xsl:variable>
			<!--Resource ID-->
			<xsl:value-of select="$fileName"/>
			<xsl:value-of select="$tab"/>
			<!--Title-->
			<xsl:value-of select="$fileName"/>
			<xsl:value-of select="$tab"/>
			<!--Title (alternative)-->
			<xsl:value-of select="$tab"/>
			<!--Creator-->
			<xsl:value-of select="$tab"/>
			<!--Contributor-->
			<xsl:value-of select="$tab"/>
			<!--Subject-->
			<xsl:value-of select="$tab"/>
			<!--Topic-->
			<xsl:value-of select="$tab"/>
			<!--Location (subject)-->
			<xsl:value-of select="$tab"/>
			<!--Location (coordinates)-->
			<xsl:value-of select="$tab"/>
			<!--Name(s) (subject)-->
			<xsl:value-of select="$tab"/>
			<!--Description-->
			<xsl:value-of select="$tab"/>
			<!--Publisher (digital)-->			
			<xsl:text>Washington State Library</xsl:text>
			<xsl:value-of select="$tab"/>
			<!--Publisher (original)-->
			<xsl:value-of select="$tab"/>
			<!--Date (digital)-->
			<xsl:call-template name="dateDigital">
				<xsl:with-param name="resourceID" select="$fileName"/>
			</xsl:call-template>
			<xsl:value-of select="$tab"/>
			<!--Date (original)-->
			<xsl:value-of select="$tab"/>
			<!--Date (hidden)-->
			<xsl:value-of select="$tab"/>
			<!--Type -->
			<xsl:value-of select="$tab"/>
			<!--Language-->
			<xsl:value-of select="$tab"/>
			<!--Related items-->
			<xsl:value-of select="$tab"/>
			<!--Contributing institution-->
			<xsl:value-of select="$tab"/>
			<!--Collection-->
			<xsl:value-of select="$tab"/>
			<!--Access file format-->
			<xsl:if test="contains(File:Directory, '_Web')">
				<xsl:call-template name="fileType"/>
			</xsl:if>	
			<xsl:value-of select="$tab"/>
			<!--Access file requires-->
			<xsl:value-of select="$tab"/>
			<!--Access file specifications-->
			<xsl:if test="contains(File:Directory, '_Web')">			
				<xsl:call-template name="fileSize"/>
				<xsl:call-template name="pixelGroup"/>
				<xsl:call-template name="software"/>
			</xsl:if>
			<xsl:value-of select="$tab"/>	
			<!--Digitization specifications-->
			<xsl:choose>
				<xsl:when test="contains(File:Directory, '_Web')">
					<xsl:for-each select="following-sibling::rdf:Description[contains(File:Directory, '_Archival')][substring-before(File:FileName, '.') = $fileName]">
						<xsl:call-template name="digSpecs"/>
					</xsl:for-each>					
				</xsl:when>
				<xsl:otherwise>
					<xsl:call-template name="digSpecs"/>
				</xsl:otherwise>
			</xsl:choose>
			<xsl:value-of select="$tab"/>
			<!--Source item specs-->
			<xsl:value-of select="$tab"/>
			<!--Notes-->
			<xsl:value-of select="$tab"/>
			<!--Rights and use-->
			<xsl:text>http://www.washingtonruralheritage.org/alias/index.php?page=legal</xsl:text>
			<xsl:value-of select="$tab"/>
			<!--Transcript-->
			<xsl:value-of select="$tab"/>
			<!--Object ID -->
     		<xsl:value-of select="File:FileName"/>
		</xsl:for-each>
	</xsl:template>
	<xsl:template name="fileType">
		<xsl:value-of select="File:MIMEType"/>
	</xsl:template>
	<xsl:template name="fileSize">
		<xsl:if test="File:FileSize">
			<xsl:text>filesize: </xsl:text>
			<xsl:value-of select="File:FileSize"/>
			<xsl:text>; </xsl:text>
		</xsl:if>
	</xsl:template>
	<xsl:template name="dateDigital">
		<xsl:param name="resourceID"/>
		<xsl:choose>
			<xsl:when test="contains(File:Directory, '_Web')">
				<xsl:for-each select="following-sibling::rdf:Description[File:FileName = concat($resourceID, '.tif')]">
					<xsl:value-of select="concat(substring(File:FileModifyDate, 1,4), '-', substring(File:FileModifyDate, 6,2), '-', substring(File:FileModifyDate, 9,2))"/>
				</xsl:for-each>			
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="concat(substring(File:FileModifyDate, 1,4), '-', substring(File:FileModifyDate, 6,2), '-', substring(File:FileModifyDate, 9,2))"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<xsl:template name="digSpecs">
		<xsl:text>master file format: </xsl:text>
		<xsl:call-template name="fileType"/>
		<xsl:text>; </xsl:text>
		<xsl:text>master filesize</xsl:text>
		<xsl:call-template name="fileSize"/>
		<xsl:call-template name="pixelGroup"/>
		<xsl:text>capture hardware: </xsl:text>	
	</xsl:template>	
	<xsl:template name="pixelGroup">
		<xsl:variable name="bitDepth">
			<xsl:choose>
				<xsl:when test="contains(IFD0:BitsPerSample, ' ')">
					<xsl:value-of select="substring-before(IFD0:BitsPerSample, ' ') * IFD0:SamplesPerPixel"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="IFD0:BitsPerSample * IFD0:SamplesPerPixel"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="IFD0:SamplesPerPixel and IFD0:BitsPerSample">
			<xsl:text>bit depth: </xsl:text>
			<xsl:value-of select="$bitDepth"/>
			<xsl:text>bits per pixel; </xsl:text>
		</xsl:if>
		<xsl:if test="IFD0:PhotometricInterpretation">
			<xsl:variable name="colorMode">
				<xsl:choose>
					<xsl:when test="IFD0:PhotometricInterpretation = 'BlackIsZero' and $bitDepth = '1'">
						<xsl:text>black and white</xsl:text>
					</xsl:when>
					<xsl:when test="IFD0:PhotometricInterpretation = 'BlackIsZero'">
						<xsl:text>grayscale</xsl:text>
					</xsl:when>
					<xsl:when test="IFD0:PhotometricInterpretation = 'RGB'">
						<xsl:text>rgb</xsl:text>
					</xsl:when>
				</xsl:choose>
			</xsl:variable>
			<xsl:text>color mode: </xsl:text>
			<xsl:value-of select="$colorMode"/>
			<xsl:text>; </xsl:text>
		</xsl:if>
		<xsl:if test="Composite:ImageSize">
			<xsl:text>pixel dimensions: </xsl:text>
			<xsl:value-of select="Composite:ImageSize"/>
			<xsl:text>; </xsl:text>
		</xsl:if>
		<xsl:if test="IFD0:XResolution = IFD0:YResolution">
			<xsl:text>resolution: </xsl:text>
			<xsl:value-of select="IFD0:XResolution"/>
			<xsl:text>ppi; </xsl:text>
		</xsl:if>
	</xsl:template>
	<xsl:template name="software">
		<xsl:if test="IFD0:Software">
			<xsl:text>compression software: </xsl:text>
			<xsl:value-of select="IFD0:Software"/>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>